Index: LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 1750)
@@ -2,4 +2,5 @@
 !
 MODULE traclmdz_mod
+
 ! 
 ! In this module all tracers specific to LMDZ are treated. This module is used 
@@ -117,5 +118,15 @@
     REAL, DIMENSION(klev)          :: mintmp, maxtmp
     LOGICAL                        :: zero
-
+! RomP >>> profil initial Be7
+      integer ilesfil
+      parameter (ilesfil=1)
+      integer  irr,kradio
+      real     beryllium(klon,klev)
+! profil initial Pb210
+      integer ilesfil2
+      parameter (ilesfil2=1)
+      integer  irr2,kradio2
+      real     plomb(klon,klev)
+!! RomP <<<
 ! --------------------------------------------
 ! Allocation
@@ -148,4 +159,11 @@
 
     lessivage  = .TRUE.
+!!jyg(20130206) : le choix d activation du lessivage est fait dans phytrac avec iflag_lscav
+!!    call getin('lessivage',lessivage)
+!!    if(lessivage) then
+!!     print*,'lessivage lsc ON'
+!!    else
+!!     print*,'lessivage lsc OFF'
+!!    endif
     aerosol(:) = .FALSE.  ! Tous les traceurs sont des gaz par defaut
     
@@ -161,4 +179,23 @@
        ELSE IF ( tname(iiq) == "PB") THEN
           id_pb=it ! plomb
+! RomP >>> profil initial de PB210 
+     open (ilesfil2,file='prof.pb210',status='old',iostat=irr2)
+     IF (irr2 == 0) THEN 
+      read(ilesfil2,*) kradio2
+      print*,'number of levels for pb210 profile ',kradio2
+      do k=kradio2,1,-1
+       read (ilesfil2,*) plomb(:,k)
+      enddo
+      close(ilesfil2)
+      do k=1,klev
+       do i=1,klon
+         tr_seri(i,k,id_pb)=plomb(i,k)
+!!        print*, 'tr_seri',i,k,tr_seri(i,k,id_pb)
+        enddo
+      enddo
+     ELSE
+       print *, 'Prof.pb210 does not exist: use restart values'
+     ENDIF
+! RomP <<<
        ELSE IF ( tname(iiq) == "Aga" .OR. tname(iiq) == "AGA" ) THEN
           ! Age of stratospheric air
@@ -183,6 +220,27 @@
           radio(id_be) = .TRUE.
           aerosol(id_be) = .TRUE. ! le Be est un aerosol
-          CALL init_be(pctsrf,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
+!jyg le 13/03/2013 ; ajout de pplay en argument de init_be
+!!!          CALL init_be(pctsrf,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
+          CALL init_be(pctsrf,pplay,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
           WRITE(lunout,*) 'Initialisation srcBe: OK'
+! RomP >>> profil initial de Be7
+      open (ilesfil,file='prof.be7',status='old',iostat=irr)
+      IF (irr == 0) THEN 
+       read(ilesfil,*) kradio
+       print*,'number of levels for Be7 profile ',kradio
+       do k=kradio,1,-1
+        read (ilesfil,*) beryllium(:,k)
+       enddo
+       close(ilesfil)
+       do k=1,klev
+         do i=1,klon
+          tr_seri(i,k,id_be)=beryllium(i,k)
+!!        print*, 'tr_seri',i,k,tr_seri(i,k,id_be)
+         enddo
+       enddo
+     ELSE
+       print *, 'Prof.Be7 does not exist: use restart values'
+     ENDIF
+! RomP <<<
        ELSE IF (tname(iiq)=="O3" .OR. tname(iiq)=="o3") THEN
           ! Recherche de l'ozone : parametrization de la chimie par Cariolle
@@ -280,5 +338,6 @@
        cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon, couchelimite, sh, &
        rh, pphi, ustar, zu10m, zv10m, &
-       tr_seri, source, solsym, d_tr_cl, zmasse)
+!!          tr_seri, source, solsym, d_tr_cl, zmasse)                      !RomP
+          tr_seri, source, solsym, d_tr_cl,d_tr_dec, zmasse)               !RomP
     
     USE dimphy
@@ -316,10 +375,10 @@
 !--------------
 !
-    REAL,DIMENSION(klon),INTENT(IN)      :: cdragh  ! coeff drag pour T et Q
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: coefh   ! diffusivite turb (m**2/s)
-    REAL,DIMENSION(klon),INTENT(IN)      :: yu1     ! vents au premier niveau
-    REAL,DIMENSION(klon),INTENT(IN)      :: yv1     ! vents au premier niveau
+    REAL,DIMENSION(klon),INTENT(IN)      :: cdragh     ! coeff drag pour T et Q
+    REAL,DIMENSION(klon,klev),INTENT(IN) :: coefh      ! coeff melange CL (m**2/s)
+    REAL,DIMENSION(klon),INTENT(IN)      :: yu1        ! vents au premier niveau
+    REAL,DIMENSION(klon),INTENT(IN)      :: yv1        ! vents au premier niveau
     LOGICAL,INTENT(IN)                   :: couchelimite
-    REAL,DIMENSION(klon,klev),INTENT(IN) :: sh      ! humidite specifique
+    REAL,DIMENSION(klon,klev),INTENT(IN) :: sh         ! humidite specifique
     REAL,DIMENSION(klon,klev),INTENT(IN) :: rh      ! Humidite relative
     REAL,DIMENSION(klon,klev),INTENT(IN) :: pphi    ! geopotentie
Index: LMDZ5/branches/testing/libf/phylmd/write_histrac.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/write_histrac.h	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/write_histrac.h	(revision 1750)
@@ -10,4 +10,7 @@
      CALL histwrite_phy(nid_tra,.FALSE.,"aire",itau_w,airephy)
      CALL histwrite_phy(nid_tra,.FALSE.,"zmasse",itau_w,zmasse)
+! RomP >>>
+     CALL histwrite_phy(nid_tra,.FALSE.,"sourceBE",itau_w,sourceBE)
+! RomP <<<
 
 !TRACEURS
@@ -20,7 +23,14 @@
 
 ! TD LESSIVAGE       
-        IF (lessivage .AND. aerosol(it)) THEN
-           CALL histwrite_phy(nid_tra,.FALSE.,"fl"//tname(iiq),itau_w,flestottr(:,:,it))
+      IF (lessivage .AND. aerosol(it)) THEN
+        CALL histwrite_phy(nid_tra,.FALSE.,"fl"//tname(iiq),itau_w,flestottr(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_ls_"//tname(iiq),itau_w,d_tr_ls(:,:,it))
+        IF(iflag_lscav .EQ. 3 .OR. iflag_lscav .EQ. 4) then
+          CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_insc_"//tname(iiq),itau_w,d_tr_insc(:,:,it))
+          CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_bcscav_"//tname(iiq),itau_w,d_tr_bcscav(:,:,it))
+          CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_evls_"//tname(iiq),itau_w,d_tr_evapls(:,:,it))
+          CALL histwrite_phy(nid_tra,.FALSE.,"qpr_ls_"//tname(iiq),itau_w,qPrls(:,it))
         ENDIF
+      ENDIF
 
 ! TD THERMIQUES
@@ -35,5 +45,31 @@
 
 ! TD COUCHE-LIMITE
+      IF (couchelimite) THEN
         CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_cl_"//tname(iiq),itau_w,d_tr_cl(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_dry_"//tname(iiq),itau_w,d_tr_dry(:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"flux_tr_dry_"//tname(iiq),itau_w,flux_tr_dry(:,it))
+      ENDIF
+
+! TD radio-decroissance
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_dec_"//tname(iiq),itau_w,d_tr_dec(:,:,it))
+
+! RomP >>>
+        IF (iflag_con.EQ.30) THEN
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_cvMA_"//tname(iiq),itau_w,dtrcvMA(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_trsp_"//tname(iiq),itau_w,d_tr_trsp(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_sscav_"//tname(iiq),itau_w,d_tr_sscav(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_sat_"//tname(iiq),itau_w,d_tr_sat(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_uscav_"//tname(iiq),itau_w,d_tr_uscav(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"tr_pr_"//tname(iiq),itau_w,qPr(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"tr_aa_"//tname(iiq),itau_w,qPa(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"tr_mel_"//tname(iiq),itau_w,qMel(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"tr_di_"//tname(iiq),itau_w,qDi(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"tr_trspdi_"//tname(iiq),itau_w,qTrdi(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"zmfd1a_"//tname(iiq),itau_w,zmfd1a(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"zmfphi2_"//tname(iiq),itau_w,zmfphi2(:,:,it))
+        CALL histwrite_phy(nid_tra,.FALSE.,"zmfdam_"//tname(iiq),itau_w,zmfdam(:,:,it))
+        ENDIF
+        CALL histwrite_phy(nid_tra,.FALSE.,"dtrdyn_"//tname(iiq),itau_w,d_tr_dyn(:,:,it))
+! RomP <<<
      ENDDO
 !---------------
@@ -65,4 +101,9 @@
  
 ! DIVERS    
+     CALL histwrite_phy(nid_tra,.FALSE.,"Mint",itau_w,Mint(:,:))
+     CALL histwrite_phy(nid_tra,.FALSE.,"frac_impa",itau_w,frac_impa(:,:))    
+     CALL histwrite_phy(nid_tra,.FALSE.,"frac_nucl",itau_w,frac_nucl(:,:))
+
+
      CALL histwrite_phy(nid_tra,.FALSE.,"pplay",itau_w,pplay)     
      CALL histwrite_phy(nid_tra,.FALSE.,"T",itau_w,t_seri)     
Index: LMDZ5/branches/testing/libf/phylmd/yamada4.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/yamada4.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/yamada4.F	(revision 1750)
@@ -37,8 +37,17 @@
 c    iflag_pbl=6 : MY 2.0
 c    iflag_pbl=7 : MY 2.0.Fournier
-c    iflag_pbl=8 : MY 2.5
-c    iflag_pbl>=9 : MY 2.5 avec diffusion verticale
-
-c.......................................................................
+c    iflag_pbl=8/9 : MY 2.5
+c       iflag_pbl=8 with special obsolete treatments for convergence
+c       with Cmpi5 NPv3.1 simulations
+c    iflag_pbl=10/11 :  New scheme M2 and N2 explicit and dissiptation exact
+c    iflag_pbl=12 = 11 with vertical diffusion off q2
+c
+c  2013/04/01 (FH hourdin@lmd.jussieu.fr)
+c     Correction for very stable PBLs (iflag_pbl=10 and 11)
+c     iflag_pbl=8 converges numerically with NPv3.1
+c     iflag_pbl=11 -> the model starts with NP from start files created by ce0l
+c                  -> the model can run with longer time-steps.
+c.......................................................................
+
       REAL dt,g,rconst
       real plev(klon,klev+1),temp(klon,klev)
@@ -63,6 +72,4 @@
       real aa(klon,klev+1),aa0,aa1
       integer iflag_pbl,ngrid
-
-
       integer nlay,nlev
 
@@ -118,27 +125,10 @@
 
 
-      if (.not.(iflag_pbl.ge.6.and.iflag_pbl.le.10)) then
+      if (.not.(iflag_pbl.ge.6.and.iflag_pbl.le.12)) then
            stop'probleme de coherence dans appel a MY'
       endif
 
       ipas=ipas+1
-      if (0.eq.1.and.first) then
-      do ig=1,1000
-         ri=(ig-800.)/500.
-         if (ri.lt.ric) then
-            zrif=frif(ri)
-         else
-            zrif=rifc
-         endif
-         if(zrif.lt.0.16) then
-            zalpha=falpha(zrif)
-            zsm=fsm(zrif)
-         else
-            zalpha=1.12
-            zsm=0.085
-         endif
-c     print*,ri,rif,zalpha,zsm
-      enddo
-      endif
+
 
 c.......................................................................
@@ -173,5 +163,7 @@
                                                      ENDDO
 c
-c.......................................................................
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Computing M^2, N^2, Richardson numbers, stability functions
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
       do k=2,klev
@@ -197,57 +189,21 @@
          endif
          zz(ig,k)=b1*m2(ig,k)*(1.-rif(ig,k))*sm(ig,k)
-c     print*,'RIF L=',k,rif(ig,k),ri*alpha(ig,k)
-
-
-                                                          enddo
-      enddo
-
-
-c====================================================================
-c   Au premier appel, on determine l et q2 de facon iterative.
-c iterration pour determiner la longueur de melange
-
-
-      if (first.or.iflag_pbl.eq.6) then
-                                                          do ig=1,ngrid
-      l0(ig)=10.
-                                                          enddo
-      do k=2,klev-1
-                                                          do ig=1,ngrid
-        l(ig,k)=l0(ig)*kap*zlev(ig,k)/(kap*zlev(ig,k)+l0(ig))
-                                                          enddo
-      enddo
-
-      do iter=1,10
-                                                          do ig=1,ngrid
-         sq(ig)=1.e-10
-         sqz(ig)=1.e-10
-                                                          enddo
-         do k=2,klev-1
-                                                          do ig=1,ngrid
-           q2(ig,k)=l(ig,k)**2*zz(ig,k)
-           l(ig,k)=fl(zlev(ig,k),l0(ig),q2(ig,k),n2(ig,k))
-           zq=sqrt(q2(ig,k))
-           sqz(ig)=sqz(ig)+zq*zlev(ig,k)*(zlay(ig,k)-zlay(ig,k-1))
-           sq(ig)=sq(ig)+zq*(zlay(ig,k)-zlay(ig,k-1))
-                                                          enddo
-         enddo
-                                                          do ig=1,ngrid
-         l0(ig)=0.2*sqz(ig)/sq(ig)
-c        l0(ig)=30.
-                                                          enddo
-c      print*,'ITER=',iter,'  L0=',l0
-
-      enddo
-
-c     print*,'Fin de l initialisation de q2 et l0'
-
-      endif ! first
-
-c====================================================================
-c  Calcul de la longueur de melange.
+                                                          enddo
+      enddo
+
+
+c====================================================================
+c  Computing the mixing length
 c====================================================================
 
 c   Mise a jour de l0
+      if (iflag_pbl==8.or.iflag_pbl==10) then
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Iterative computation of l0
+! This version is kept for iflag_pbl only for convergence
+! with NPv3.1 Cmip5 simulations
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
                                                           do ig=1,ngrid
       sq(ig)=1.e-10
@@ -263,16 +219,28 @@
                                                           do ig=1,ngrid
       l0(ig)=0.2*sqz(ig)/sq(ig)
-c        l0(ig)=30.
-                                                          enddo
-c      print*,'ITER=',iter,'  L0=',l0
-c   calcul de l(z)
+                                                          enddo
       do k=2,klev
                                                           do ig=1,ngrid
          l(ig,k)=fl(zlev(ig,k),l0(ig),q2(ig,k),n2(ig,k))
-         if(first) then
-           q2(ig,k)=l(ig,k)**2*zz(ig,k)
-         endif
-                                                          enddo
-      enddo
+                                                          enddo
+      enddo
+!     print*,'L0 cas 8 ou 10 ',l0
+
+      else
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! In all other case, the assymptotic mixing length l0 is imposed (100m)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+          l0(:)=150.
+          do k=2,klev
+                                                          do ig=1,ngrid
+             l(ig,k)=fl(zlev(ig,k),l0(ig),q2(ig,k),n2(ig,k))
+                                                          enddo
+          enddo
+!     print*,'L0 cas autres ',l0
+
+      endif
+
 
 c====================================================================
@@ -282,7 +250,5 @@
 
       do k=2,klev
-                                                          do ig=1,ngrid
-         q2(ig,k)=l(ig,k)**2*zz(ig,k)
-                                                          enddo
+         q2(:,k)=l(:,k)**2*zz(:,k)
       enddo
 
@@ -342,5 +308,5 @@
       enddo
 
-      else if (iflag_pbl.ge.8) then
+      else if (iflag_pbl==8.or.iflag_pbl==9) then
 c====================================================================
 c   Yamada 2.5 a la Didi
@@ -366,5 +332,5 @@
 c     print*,'0L=',k,l(ig,k),delta(ig,k),km(ig,k)
          qpre=sqrt(q2(ig,k))
-         if (iflag_pbl.eq.8 ) then
+!        if (iflag_pbl.eq.8 ) then
             if (aa(ig,k).gt.0.) then
                q2(ig,k)=(qpre+aa(ig,k)*qpre*qpre)**2
@@ -372,15 +338,32 @@
                q2(ig,k)=(qpre/(1.-aa(ig,k)*qpre))**2
             endif
-         else ! iflag_pbl=9
-            if (aa(ig,k)*qpre.gt.0.9) then
-               q2(ig,k)=(qpre*10.)**2
-            else
-               q2(ig,k)=(qpre/(1.-aa(ig,k)*qpre))**2
-            endif
-         endif
+!        else ! iflag_pbl=9
+!           if (aa(ig,k)*qpre.gt.0.9) then
+!              q2(ig,k)=(qpre*10.)**2
+!           else
+!              q2(ig,k)=(qpre/(1.-aa(ig,k)*qpre))**2
+!           endif
+!        endif
          q2(ig,k)=min(max(q2(ig,k),1.e-10),1.e4)
 c     print*,'Q2 L=',k,q2(ig,k),qpre*qpre
                                                           enddo
       enddo
+
+      else if (iflag_pbl>=10) then
+
+!        print*,'Schema mixte D'
+!        print*,'Longueur ',l(:,:)
+         do k=2,klev-1
+            l(:,k)=max(l(:,k),1.)
+            km(:,k)=l(:,k)*sqrt(q2(:,k))*sm(:,k)
+            q2(:,k)=q2(:,k)+dt*km(:,k)*m2(:,k)*(1.-rif(:,k))
+            q2(:,k)=min(max(q2(:,k),1.e-10),1.e4)
+            q2(:,k)=1./(1./sqrt(q2(:,k))+dt/(2*l(:,k)*b1))
+            q2(:,k)=q2(:,k)*q2(:,k)
+         enddo
+
+
+      else
+         stop'Cas nom prevu dans yamada4'
 
       endif ! Fin du cas 8
@@ -404,5 +387,5 @@
 
 ! Transport diffusif vertical de la TKE.
-      if (iflag_pbl.ge.9) then
+      if (iflag_pbl.ge.12) then
 !       print*,'YAMADA VDIF'
         q2(:,1)=q2(:,2)
@@ -425,8 +408,10 @@
                                                           enddo
 
-!      print*,'pblhmin ',pblhmin
+!     print*,'pblhmin ',pblhmin
 CTest a remettre 21 11 02
 c test abd 13 05 02      if(0.eq.1) then
-      if(1.eq.1) then
+      if(1==1) then
+      if(iflag_pbl==8.or.iflag_pbl==10) then
+
       do k=2,klev
          do ig=1,ngrid
@@ -449,4 +434,35 @@
          enddo
       enddo
+
+      else
+
+      do k=2,klev
+         do ig=1,ngrid
+            if (teta(ig,2).gt.teta(ig,1)) then
+               qmin=ustar(ig)*(max(1.-zlev(ig,k)/pblhmin(ig),0.))**2
+               kmin=kap*zlev(ig,k)*qmin
+            else
+               kmin=-1. ! kmin n'est utilise que pour les SL stables.
+            endif 
+            if (kn(ig,k).lt.kmin.or.km(ig,k).lt.kmin) then
+c               print*,'Seuil min Km K=',k,kmin,km(ig,k),kn(ig,k)
+c     s           ,sqrt(q2(ig,k)),pblhmin(ig),qmin/sm(ig,k)
+               kn(ig,k)=kmin
+               km(ig,k)=kmin
+               kq(ig,k)=kmin
+c   la longueur de melange est suposee etre l= kap z
+c   K=l q Sm d'ou q2=(K/l Sm)**2
+               sm(ig,k)=1.
+               alpha(ig,k)=1.
+               q2(ig,k)=min((qmin/sm(ig,k))**2,10.)
+               zq=sqrt(q2(ig,k))
+               km(ig,k)=l(ig,k)*zq*sm(ig,k)
+               kn(ig,k)=km(ig,k)*alpha(ig,k)
+               kq(ig,k)=l(ig,k)*zq*0.2
+            endif
+         enddo
+      enddo
+      endif
+
       endif
 
Index: LMDZ5/branches/testing/tools/install_1d_src.sh
===================================================================
--- LMDZ5/branches/testing/tools/install_1d_src.sh	(revision 1707)
+++ LMDZ5/branches/testing/tools/install_1d_src.sh	(revision 1750)
@@ -59,5 +59,5 @@
  ln -s ../dyn3d/infotrac.F90 .
  ln -s ../dyn3d/conf_gcm.F .
- ln -s ../dyn3d/pres2lev.F90 .
+ ln -s ../dyn3d/pres2lev* .
  ln -s ../dyn3d/control_mod.F90 .
  ln -s ../dyn3d/q_sat.F .
